import { FormFieldPresence } from '@sanity/base/presence';
import { Path, Marker } from '@sanity/types';
import React, { PureComponent } from 'react';
import { CodeInputType, CodeInputValue } from './types';
import 'brace/mode/batchfile';
import 'brace/mode/css';
import 'brace/mode/html';
import 'brace/mode/typescript';
import 'brace/mode/javascript';
import 'brace/mode/json';
import 'brace/mode/jsx';
import 'brace/mode/markdown';
import 'brace/mode/php';
import 'brace/mode/sass';
import 'brace/mode/scss';
import 'brace/mode/python';
import 'brace/mode/sh';
import 'brace/mode/text';
import './groq';
import 'brace/theme/github';
import 'brace/theme/monokai';
import 'brace/theme/terminal';
import 'brace/theme/tomorrow';
export interface CodeInputProps {
    compareValue?: CodeInputValue;
    focusPath: Path;
    level: number;
    markers: Marker[];
    onBlur: () => void;
    onChange: (...args: any[]) => void;
    onFocus: (path: Path) => void;
    presence: FormFieldPresence[];
    readOnly?: boolean;
    type: CodeInputType;
    value?: CodeInputValue;
}
export default class CodeInput extends PureComponent<CodeInputProps> {
    editor: any;
    _inputId?: string;
    focus(): void;
    componentWillUnmount(): void;
    handleCodeChange: (code: string) => void;
    handleToggleSelectLine: (lineNumber: number) => void;
    handleGutterMouseDown: (event: any) => void;
    handleEditorLoad: (editor: any) => void;
    handleLanguageChange: (event: React.ChangeEvent<HTMLSelectElement>) => void;
    handleFilenameChange: (event: React.ChangeEvent<HTMLInputElement>) => void;
    getLanguageAlternatives(): {
        title: string;
        value: string;
    }[];
    getTheme(): any;
    renderEditor: () => JSX.Element;
    handleLanguageFocus: () => void;
    handleCodeFocus: () => void;
    handleFilenameFocus: () => void;
    render(): JSX.Element;
}
//# sourceMappingURL=CodeInput.d.ts.map